<?
/********************************
 IP-SYMCON Event Scripting
*********************************
File     : AudioPlayer.ips.php
Trigger  : OnChange: Track Position
			  OnChange: Status
			  OnChange: Volume_Target
Interval :
Author   : HJH
Project  : AudioPlayer
Date     : 11.04.09
********************************/

/********************************
Media Player Status:
 1: Play
 2: Pause
 3: Stop

Play Button Status:
 0: Stop (grau)
 1: Play (dunkelgrn)
 3: Play (hellgrn)
 5: Pause (gelb)

Stop Button Status:
 0: Stop (grau)
 1: Play (blau)
********************************/

require_once "AudioPlayer_IDs.ips.php";

$project = "AudioPlayerV2";
$projectPath = IPS_GetKernelDir(). "scripts\\". $project. "\\";
$imagePath = IPS_GetKernelDir(). "media\\". $project. "\\";
$fontSize = 14.0;

switch ($IPS_SENDER)
{
	case "Designer": // Eingaben, die im Designer gemacht wurden ****************
		switch ($IPS_COMPONENT)
		{
			case "Btn_Play": // Play-Taste wurde gedrckt -------------------------
				switch (GetValueInteger(Btn_Play_Status))
				{
					case 0: // Taste war im Stop Modus ------------------------------
						// Titel anzeigen
						$path = GetValueString(Song_to_play);
						$name = basename($path);
						$name = substr($name, 0, strrpos($name, "."));														// Datei-Endung ausblenden
						$img = imagecreatefrompng($projectPath. "Title empty.png");										// leeren Titel als Bild laden
						$x2 = imagesx($img)>>1;																						// Mitte des Bildes ermitteln
						$textBox = imageftbbox($fontSize, 0.0, "arialbd.ttf", $name);									// Gre des Schriftzuges ermitteln
						$breite = $textBox[2]>>1;																					// halbe Breite ermitteln
						imagefttext( $img, $fontSize, 0.0, $x2-$breite, 22, 0xf0f0f0, "arialbd.ttf", $name);	// heller Schriftschatten
						imagefttext( $img, $fontSize, 0.0, $x2-$breite+1, 22+2, 0x0, "arialbd.ttf", $name);		// dunkle Schrift
						imagepng($img, $imagePath. "Title.png");																// Bild mit dem Titel abspeichern
						imagedestroy($img);																							// vom Bild belegten Speicher wieder freigeben

						SetValueInteger(Btn_Stop_Status, 1);
						SetValueInteger(Btn_Play_Status, 1);	// in Play Modus schalten
						WAC_PlayFile(AudioPlayer, $path);
					break;
					case 1: // Taste war im Play Modus ------------------------------
					case 3:
						SetValueInteger(Btn_Play_Status, 5);	// in Pause Modus schalten
						WAC_Pause(AudioPlayer);
					break;
					case 5: // Taste war im Pause Modus -----------------------------
						SetValueInteger(Btn_Play_Status, 1);	// in Play Modus schalten
						WAC_Play(AudioPlayer);
					break;
				}
			break;
			case "Btn_Stop": // Stop-Taste wurde gedrckt -------------------------
				switch (GetValueInteger(Btn_Stop_Status))
				{
					case 0: // Taste war im Stop Modus ------------------------------
					break;
					case 1: // Taste war im Play Modus ------------------------------
						WAC_Stop(AudioPlayer);
						SetValueInteger(Btn_Play_Status, 0);	// Play-Taste in Stop Modus schalten
						SetValueInteger(Btn_Stop_Status, 0);	// Stop-Taste in Stop Modus schalten
					break;
				}
			break;
		}
	break;

	case "Variable": // Events, die durch Variablen ausgelst wurden ************
		switch ($IPS_VARIABLE)
		{
			case Track_Position: // aktuelle Position liegt vor -------------------
				// Blinken der Play-Taste
				if (GetValueInteger(Btn_Play_Status) == 1)
					SetValueInteger(Btn_Play_Status, 3);
				else if (GetValueInteger(Btn_Play_Status) == 3)
					SetValueInteger(Btn_Play_Status, 1);

				// Player-Position (std:min:sek) in Slider-Position (0...200) umrechnen
				$arr = explode(":", GetValueString(Track_Length)); // Gesamtlnge
				$len = 3600*$arr[0] + 60*$arr[1] + $arr[2];
				$arr = explode(":", $IPS_VALUE);                   // aktuelle Position
				$pos = 3600*$arr[0] + 60*$arr[1] + $arr[2];
				$sld = ($len*$pos>0) ? (int)round(200/$len*$pos) : 0;
				SetValueInteger(Slider, $sld);                     // neue Slider-Position
			break;
			case Slider_Target: // neue Positionsvorgabe liegt vor ----------------
				//$arr = explode(":", GetValueString(Track_Length));
				//$len = 3600*$arr[0] + 60*$arr[1] + $arr[2];
				//$pos = (int)round($len/200*GetValueInteger(Slider_Target));
				//WAC_SetPosition(AudioPlayer, $pos);
			break;
			case Status: // Musikstck ist am Ende angekommen ---------------------
				if ($IPS_VALUE == 3)
				{
					SetValueInteger(Btn_Play_Status, 0);	// Play-Taste in Stop Modus schalten
					SetValueInteger(Btn_Stop_Status, 0);	// Stop-Taste in Stop Modus schalten
				}
			break;
			case Volume_Target: // Lautstrke ndern ------------------------------
				$vol = 333.33 * (log10(2.0) - log10(2.0 - $IPS_VALUE/100.0));
				WAC_SetVolume(AudioPlayer, (integer)($vol));
			break;
			default:
			break;
		}
	break;
}
?>
